#include <stdio.h>
#include <stdlib.h>
#include <stdint.h>
#include <time.h>

/* https://www.wolframalpha.com/input/?i=lcm(1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,17,18,19,20)
 */
#define DEFAULT_STEPS 232792560ULL

uint64_t compute_pi_montecarlo_hits(uint64_t steps)
{
  uint64_t i;
  uint64_t n_hits = 0;

  for (i = 0; i < steps; ++i) {
    double x = (double)rand() / RAND_MAX;
    double y = (double)rand() / RAND_MAX;
    double z = (x * x) + (y * y);
    if (z < 1.0) {
      ++n_hits;
    }
  }

  return n_hits;
}

/**
 *
 */
int main(int argc, char **argv)
{
  uint64_t steps;
  uint64_t hits;
  double pi_montecarlo;

  srand(time(0));
  steps = DEFAULT_STEPS;
  hits = compute_pi_montecarlo_hits(steps);
  pi_montecarlo = 4.0 * hits / steps;

  printf("Pi: %.8f\n", pi_montecarlo);

  return 0;
}
